"""DO NOT EDIT THIS FILE!

This file is automatically @generated by githubkit using the follow command:

bash ./scripts/run-codegen.sh

See https://github.com/github/rest-api-description for more information.
"""

from __future__ import annotations

from datetime import datetime
from typing import Literal

from pydantic import Field

from githubkit.compat import GitHubModel, model_rebuild
from githubkit.typing import Missing
from githubkit.utils import UNSET


class OrgPrivateRegistryConfigurationWithSelectedRepositories(GitHubModel):
    """Organization private registry

    Private registry configuration for an organization
    """

    name: str = Field(description="The name of the private registry configuration.")
    registry_type: Literal["maven_repository", "nuget_feed", "goproxy_server"] = Field(
        description="The registry type."
    )
    username: Missing[str] = Field(
        default=UNSET,
        description="The username to use when authenticating with the private registry.",
    )
    visibility: Literal["all", "private", "selected"] = Field(
        description="Which type of organization repositories have access to the private registry. `selected` means only the repositories specified by `selected_repository_ids` can access the private registry."
    )
    selected_repository_ids: Missing[list[int]] = Field(
        default=UNSET,
        description="An array of repository IDs that can access the organization private registry when `visibility` is set to `selected`.",
    )
    created_at: datetime = Field()
    updated_at: datetime = Field()


model_rebuild(OrgPrivateRegistryConfigurationWithSelectedRepositories)

__all__ = ("OrgPrivateRegistryConfigurationWithSelectedRepositories",)
