"""DO NOT EDIT THIS FILE!

This file is automatically @generated by githubkit using the follow command:

bash ./scripts/run-codegen.sh

See https://github.com/github/rest-api-description for more information.
"""

from __future__ import annotations

from typing import Literal, Union

from pydantic import Field

from githubkit.compat import GitHubModel, model_rebuild
from githubkit.typing import Missing
from githubkit.utils import UNSET

from .group_0003 import SimpleUser
from .group_0485 import EnterpriseWebhooks
from .group_0486 import SimpleInstallation
from .group_0487 import OrganizationSimpleWebhooks
from .group_0488 import RepositoryWebhooks
from .group_0498 import WebhooksUser


class WebhookMemberEdited(GitHubModel):
    """member edited event"""

    action: Literal["edited"] = Field()
    changes: WebhookMemberEditedPropChanges = Field(
        description="The changes to the collaborator permissions"
    )
    enterprise: Missing[EnterpriseWebhooks] = Field(
        default=UNSET,
        title="Enterprise",
        description='An enterprise on GitHub. Webhook payloads contain the `enterprise` property when the webhook is configured\non an enterprise account or an organization that\'s part of an enterprise account. For more information,\nsee "[About enterprise accounts](https://docs.github.com/enterprise-cloud@latest//admin/overview/about-enterprise-accounts)."',
    )
    installation: Missing[SimpleInstallation] = Field(
        default=UNSET,
        title="Simple Installation",
        description='The GitHub App installation. Webhook payloads contain the `installation` property when the event is configured\nfor and sent to a GitHub App. For more information,\nsee "[Using webhooks with GitHub Apps](https://docs.github.com/enterprise-cloud@latest//apps/creating-github-apps/registering-a-github-app/using-webhooks-with-github-apps)."',
    )
    member: Union[WebhooksUser, None] = Field(title="User")
    organization: Missing[OrganizationSimpleWebhooks] = Field(
        default=UNSET,
        title="Organization Simple",
        description="A GitHub organization. Webhook payloads contain the `organization` property when the webhook is configured for an\norganization, or when the event occurs from activity in a repository owned by an organization.",
    )
    repository: RepositoryWebhooks = Field(
        title="Repository",
        description="The repository on GitHub where the event occurred. Webhook payloads contain the `repository` property\nwhen the event occurs from activity in a repository.",
    )
    sender: SimpleUser = Field(title="Simple User", description="A GitHub user.")


class WebhookMemberEditedPropChanges(GitHubModel):
    """WebhookMemberEditedPropChanges

    The changes to the collaborator permissions
    """

    old_permission: Missing[WebhookMemberEditedPropChangesPropOldPermission] = Field(
        default=UNSET
    )
    permission: Missing[WebhookMemberEditedPropChangesPropPermission] = Field(
        default=UNSET
    )


class WebhookMemberEditedPropChangesPropOldPermission(GitHubModel):
    """WebhookMemberEditedPropChangesPropOldPermission"""

    from_: str = Field(
        alias="from",
        description="The previous permissions of the collaborator if the action was edited.",
    )


class WebhookMemberEditedPropChangesPropPermission(GitHubModel):
    """WebhookMemberEditedPropChangesPropPermission"""

    from_: Missing[Union[str, None]] = Field(default=UNSET, alias="from")
    to: Missing[Union[str, None]] = Field(default=UNSET)


model_rebuild(WebhookMemberEdited)
model_rebuild(WebhookMemberEditedPropChanges)
model_rebuild(WebhookMemberEditedPropChangesPropOldPermission)
model_rebuild(WebhookMemberEditedPropChangesPropPermission)

__all__ = (
    "WebhookMemberEdited",
    "WebhookMemberEditedPropChanges",
    "WebhookMemberEditedPropChangesPropOldPermission",
    "WebhookMemberEditedPropChangesPropPermission",
)
