"""DO NOT EDIT THIS FILE!

This file is automatically @generated by githubkit using the follow command:

bash ./scripts/run-codegen.sh

See https://github.com/github/rest-api-description for more information.
"""

from __future__ import annotations

from datetime import datetime
from typing import Literal, Union
from typing_extensions import NotRequired, TypedDict

from .group_0001 import CvssSeveritiesType
from .group_0002 import SecurityAdvisoryEpssType
from .group_0005 import GlobalAdvisoryPropCreditsItemsType


class GlobalAdvisoryType(TypedDict):
    """GlobalAdvisory

    A GitHub Security Advisory.
    """

    ghsa_id: str
    cve_id: Union[str, None]
    url: str
    html_url: str
    repository_advisory_url: Union[str, None]
    summary: str
    description: Union[str, None]
    type: Literal["reviewed", "unreviewed", "malware"]
    severity: Literal["critical", "high", "medium", "low", "unknown"]
    source_code_location: Union[str, None]
    identifiers: Union[list[GlobalAdvisoryPropIdentifiersItemsType], None]
    references: Union[list[str], None]
    published_at: datetime
    updated_at: datetime
    github_reviewed_at: Union[datetime, None]
    nvd_published_at: Union[datetime, None]
    withdrawn_at: Union[datetime, None]
    vulnerabilities: Union[list[VulnerabilityType], None]
    cvss: Union[GlobalAdvisoryPropCvssType, None]
    cvss_severities: NotRequired[Union[CvssSeveritiesType, None]]
    epss: NotRequired[Union[SecurityAdvisoryEpssType, None]]
    cwes: Union[list[GlobalAdvisoryPropCwesItemsType], None]
    credits_: Union[list[GlobalAdvisoryPropCreditsItemsType], None]


class GlobalAdvisoryPropIdentifiersItemsType(TypedDict):
    """GlobalAdvisoryPropIdentifiersItems"""

    type: Literal["CVE", "GHSA"]
    value: str


class GlobalAdvisoryPropCvssType(TypedDict):
    """GlobalAdvisoryPropCvss"""

    vector_string: Union[str, None]
    score: Union[float, None]


class GlobalAdvisoryPropCwesItemsType(TypedDict):
    """GlobalAdvisoryPropCwesItems"""

    cwe_id: str
    name: str


class VulnerabilityType(TypedDict):
    """Vulnerability

    A vulnerability describing the product and its affected versions within a GitHub
    Security Advisory.
    """

    package: Union[VulnerabilityPropPackageType, None]
    vulnerable_version_range: Union[str, None]
    first_patched_version: Union[str, None]
    vulnerable_functions: Union[list[str], None]


class VulnerabilityPropPackageType(TypedDict):
    """VulnerabilityPropPackage

    The name of the package affected by the vulnerability.
    """

    ecosystem: Literal[
        "rubygems",
        "npm",
        "pip",
        "maven",
        "nuget",
        "composer",
        "go",
        "rust",
        "erlang",
        "actions",
        "pub",
        "other",
        "swift",
    ]
    name: Union[str, None]


__all__ = (
    "GlobalAdvisoryPropCvssType",
    "GlobalAdvisoryPropCwesItemsType",
    "GlobalAdvisoryPropIdentifiersItemsType",
    "GlobalAdvisoryType",
    "VulnerabilityPropPackageType",
    "VulnerabilityType",
)
