"""DO NOT EDIT THIS FILE!

This file is automatically @generated by githubkit using the follow command:

bash ./scripts/run-codegen.sh

See https://github.com/github/rest-api-description for more information.
"""

from __future__ import annotations

from typing_extensions import TypedDict


class SecretScanningLocationCommitType(TypedDict):
    """SecretScanningLocationCommit

    Represents a 'commit' secret scanning location type. This location type shows
    that a secret was detected inside a commit to a repository.
    """

    path: str
    start_line: float
    end_line: float
    start_column: float
    end_column: float
    blob_sha: str
    blob_url: str
    commit_sha: str
    commit_url: str


class SecretScanningLocationWikiCommitType(TypedDict):
    """SecretScanningLocationWikiCommit

    Represents a 'wiki_commit' secret scanning location type. This location type
    shows that a secret was detected inside a commit to a repository wiki.
    """

    path: str
    start_line: float
    end_line: float
    start_column: float
    end_column: float
    blob_sha: str
    page_url: str
    commit_sha: str
    commit_url: str


class SecretScanningLocationIssueBodyType(TypedDict):
    """SecretScanningLocationIssueBody

    Represents an 'issue_body' secret scanning location type. This location type
    shows that a secret was detected in the body of an issue.
    """

    issue_body_url: str


class SecretScanningLocationDiscussionTitleType(TypedDict):
    """SecretScanningLocationDiscussionTitle

    Represents a 'discussion_title' secret scanning location type. This location
    type shows that a secret was detected in the title of a discussion.
    """

    discussion_title_url: str


class SecretScanningLocationDiscussionCommentType(TypedDict):
    """SecretScanningLocationDiscussionComment

    Represents a 'discussion_comment' secret scanning location type. This location
    type shows that a secret was detected in a comment on a discussion.
    """

    discussion_comment_url: str


class SecretScanningLocationPullRequestBodyType(TypedDict):
    """SecretScanningLocationPullRequestBody

    Represents a 'pull_request_body' secret scanning location type. This location
    type shows that a secret was detected in the body of a pull request.
    """

    pull_request_body_url: str


class SecretScanningLocationPullRequestReviewType(TypedDict):
    """SecretScanningLocationPullRequestReview

    Represents a 'pull_request_review' secret scanning location type. This location
    type shows that a secret was detected in a review on a pull request.
    """

    pull_request_review_url: str


__all__ = (
    "SecretScanningLocationCommitType",
    "SecretScanningLocationDiscussionCommentType",
    "SecretScanningLocationDiscussionTitleType",
    "SecretScanningLocationIssueBodyType",
    "SecretScanningLocationPullRequestBodyType",
    "SecretScanningLocationPullRequestReviewType",
    "SecretScanningLocationWikiCommitType",
)
