"""DO NOT EDIT THIS FILE!

This file is automatically @generated by githubkit using the follow command:

bash ./scripts/run-codegen.sh

See https://github.com/github/rest-api-description for more information.
"""

from __future__ import annotations

from datetime import datetime
from typing import Literal, Union
from typing_extensions import NotRequired, TypedDict

from .group_0056 import BypassResponseType


class SecretScanningBypassRequestType(TypedDict):
    """Secret scanning bypass request

    A bypass request made by a user asking to be exempted from push protection in
    this repository.
    """

    id: NotRequired[int]
    number: NotRequired[int]
    repository: NotRequired[SecretScanningBypassRequestPropRepositoryType]
    organization: NotRequired[SecretScanningBypassRequestPropOrganizationType]
    requester: NotRequired[SecretScanningBypassRequestPropRequesterType]
    request_type: NotRequired[str]
    data: NotRequired[Union[list[SecretScanningBypassRequestPropDataItemsType], None]]
    resource_identifier: NotRequired[str]
    status: NotRequired[
        Literal[
            "pending", "denied", "approved", "cancelled", "completed", "expired", "open"
        ]
    ]
    requester_comment: NotRequired[Union[str, None]]
    expires_at: NotRequired[datetime]
    created_at: NotRequired[datetime]
    responses: NotRequired[Union[list[BypassResponseType], None]]
    url: NotRequired[str]
    html_url: NotRequired[str]


class SecretScanningBypassRequestPropRepositoryType(TypedDict):
    """SecretScanningBypassRequestPropRepository

    The repository the bypass request is for.
    """

    id: NotRequired[int]
    name: NotRequired[str]
    full_name: NotRequired[str]


class SecretScanningBypassRequestPropOrganizationType(TypedDict):
    """SecretScanningBypassRequestPropOrganization

    The organization associated with the repository the bypass request is for.
    """

    id: NotRequired[int]
    name: NotRequired[str]


class SecretScanningBypassRequestPropRequesterType(TypedDict):
    """SecretScanningBypassRequestPropRequester

    The user who requested the bypass.
    """

    actor_id: NotRequired[int]
    actor_name: NotRequired[str]


class SecretScanningBypassRequestPropDataItemsType(TypedDict):
    """SecretScanningBypassRequestPropDataItems"""

    secret_type: NotRequired[str]
    bypass_reason: NotRequired[Literal["used_in_tests", "false_positive", "fix_later"]]
    path: NotRequired[str]
    branch: NotRequired[str]


__all__ = (
    "SecretScanningBypassRequestPropDataItemsType",
    "SecretScanningBypassRequestPropOrganizationType",
    "SecretScanningBypassRequestPropRepositoryType",
    "SecretScanningBypassRequestPropRequesterType",
    "SecretScanningBypassRequestType",
)
