"""DO NOT EDIT THIS FILE!

This file is automatically @generated by githubkit using the follow command:

bash ./scripts/run-codegen.sh

See https://github.com/github/rest-api-description for more information.
"""

from __future__ import annotations

from typing import Any, Literal, Union
from typing_extensions import NotRequired, TypeAlias, TypedDict

from .group_0003 import SimpleUserType


class PersonalAccessTokenRequestType(TypedDict):
    """Personal Access Token Request

    Details of a Personal Access Token Request.
    """

    id: int
    owner: SimpleUserType
    permissions_added: PersonalAccessTokenRequestPropPermissionsAddedType
    permissions_upgraded: PersonalAccessTokenRequestPropPermissionsUpgradedType
    permissions_result: PersonalAccessTokenRequestPropPermissionsResultType
    repository_selection: Literal["none", "all", "subset"]
    repository_count: Union[int, None]
    repositories: Union[list[PersonalAccessTokenRequestPropRepositoriesItemsType], None]
    created_at: str
    token_id: int
    token_name: str
    token_expired: bool
    token_expires_at: Union[str, None]
    token_last_used_at: Union[str, None]


class PersonalAccessTokenRequestPropRepositoriesItemsType(TypedDict):
    """PersonalAccessTokenRequestPropRepositoriesItems"""

    full_name: str
    id: int
    name: str
    node_id: str
    private: bool


class PersonalAccessTokenRequestPropPermissionsAddedType(TypedDict):
    """PersonalAccessTokenRequestPropPermissionsAdded

    New requested permissions, categorized by type of permission.
    """

    organization: NotRequired[
        PersonalAccessTokenRequestPropPermissionsAddedPropOrganizationType
    ]
    repository: NotRequired[
        PersonalAccessTokenRequestPropPermissionsAddedPropRepositoryType
    ]
    other: NotRequired[PersonalAccessTokenRequestPropPermissionsAddedPropOtherType]


PersonalAccessTokenRequestPropPermissionsAddedPropOrganizationType: TypeAlias = dict[
    str, Any
]
"""PersonalAccessTokenRequestPropPermissionsAddedPropOrganization
"""


PersonalAccessTokenRequestPropPermissionsAddedPropRepositoryType: TypeAlias = dict[
    str, Any
]
"""PersonalAccessTokenRequestPropPermissionsAddedPropRepository
"""


PersonalAccessTokenRequestPropPermissionsAddedPropOtherType: TypeAlias = dict[str, Any]
"""PersonalAccessTokenRequestPropPermissionsAddedPropOther
"""


class PersonalAccessTokenRequestPropPermissionsUpgradedType(TypedDict):
    """PersonalAccessTokenRequestPropPermissionsUpgraded

    Requested permissions that elevate access for a previously approved request for
    access, categorized by type of permission.
    """

    organization: NotRequired[
        PersonalAccessTokenRequestPropPermissionsUpgradedPropOrganizationType
    ]
    repository: NotRequired[
        PersonalAccessTokenRequestPropPermissionsUpgradedPropRepositoryType
    ]
    other: NotRequired[PersonalAccessTokenRequestPropPermissionsUpgradedPropOtherType]


PersonalAccessTokenRequestPropPermissionsUpgradedPropOrganizationType: TypeAlias = dict[
    str, Any
]
"""PersonalAccessTokenRequestPropPermissionsUpgradedPropOrganization
"""


PersonalAccessTokenRequestPropPermissionsUpgradedPropRepositoryType: TypeAlias = dict[
    str, Any
]
"""PersonalAccessTokenRequestPropPermissionsUpgradedPropRepository
"""


PersonalAccessTokenRequestPropPermissionsUpgradedPropOtherType: TypeAlias = dict[
    str, Any
]
"""PersonalAccessTokenRequestPropPermissionsUpgradedPropOther
"""


class PersonalAccessTokenRequestPropPermissionsResultType(TypedDict):
    """PersonalAccessTokenRequestPropPermissionsResult

    Permissions requested, categorized by type of permission. This field
    incorporates `permissions_added` and `permissions_upgraded`.
    """

    organization: NotRequired[
        PersonalAccessTokenRequestPropPermissionsResultPropOrganizationType
    ]
    repository: NotRequired[
        PersonalAccessTokenRequestPropPermissionsResultPropRepositoryType
    ]
    other: NotRequired[PersonalAccessTokenRequestPropPermissionsResultPropOtherType]


PersonalAccessTokenRequestPropPermissionsResultPropOrganizationType: TypeAlias = dict[
    str, Any
]
"""PersonalAccessTokenRequestPropPermissionsResultPropOrganization
"""


PersonalAccessTokenRequestPropPermissionsResultPropRepositoryType: TypeAlias = dict[
    str, Any
]
"""PersonalAccessTokenRequestPropPermissionsResultPropRepository
"""


PersonalAccessTokenRequestPropPermissionsResultPropOtherType: TypeAlias = dict[str, Any]
"""PersonalAccessTokenRequestPropPermissionsResultPropOther
"""


__all__ = (
    "PersonalAccessTokenRequestPropPermissionsAddedPropOrganizationType",
    "PersonalAccessTokenRequestPropPermissionsAddedPropOtherType",
    "PersonalAccessTokenRequestPropPermissionsAddedPropRepositoryType",
    "PersonalAccessTokenRequestPropPermissionsAddedType",
    "PersonalAccessTokenRequestPropPermissionsResultPropOrganizationType",
    "PersonalAccessTokenRequestPropPermissionsResultPropOtherType",
    "PersonalAccessTokenRequestPropPermissionsResultPropRepositoryType",
    "PersonalAccessTokenRequestPropPermissionsResultType",
    "PersonalAccessTokenRequestPropPermissionsUpgradedPropOrganizationType",
    "PersonalAccessTokenRequestPropPermissionsUpgradedPropOtherType",
    "PersonalAccessTokenRequestPropPermissionsUpgradedPropRepositoryType",
    "PersonalAccessTokenRequestPropPermissionsUpgradedType",
    "PersonalAccessTokenRequestPropRepositoriesItemsType",
    "PersonalAccessTokenRequestType",
)
