"""DO NOT EDIT THIS FILE!

This file is automatically @generated by githubkit using the follow command:

bash ./scripts/run-codegen.sh

See https://github.com/github/rest-api-description for more information.
"""

from collections.abc import Awaitable
import importlib
from typing import (
    TYPE_CHECKING,
    Any,
    Callable,
    Literal,
    Optional,
    TypeVar,
    Union,
    overload,
)
from typing_extensions import ParamSpec
from weakref import WeakKeyDictionary, ref

from githubkit.rest.paginator import Paginator

from . import LATEST_VERSION, VERSION_TYPE, VERSIONS

if TYPE_CHECKING:
    from githubkit import GitHubCore, Response

    from .ghec_v2022_11_28.rest import RestNamespace as GhecV20221128RestNamespace
    from .v2022_11_28.rest import RestNamespace as V20221128RestNamespace


CP = ParamSpec("CP")
CT = TypeVar("CT")
RT = TypeVar("RT")

R = Union[
    Callable[CP, "Response[RT]"],
    Callable[CP, Awaitable["Response[RT]"]],
]

if TYPE_CHECKING:

    class _VersionProxy(V20221128RestNamespace): ...

else:
    _VersionProxy = object


class RestVersionSwitcher(_VersionProxy):
    _cached_namespaces: "WeakKeyDictionary[GitHubCore, dict[VERSION_TYPE, Any]]" = (
        WeakKeyDictionary()
    )

    if not TYPE_CHECKING:

        def __getattr__(self, name: str) -> Any:
            if name.startswith("_"):
                raise AttributeError(
                    f"'{self.__class__.__name__}' object has no attribute '{name}'"
                )
            namespace = self()
            return getattr(namespace, name)

    def __init__(self, github: "GitHubCore"):
        self._github_ref = ref(github)

    @property
    def _github(self) -> "GitHubCore":
        if g := self._github_ref():
            return g
        raise RuntimeError(
            "GitHub client has already been collected. "
            "Do not use the namespace after the client has been collected."
        )

    @overload
    def paginate(
        self,
        request: "R[CP, list[RT]]",
        map_func: None = None,
        *args: CP.args,
        **kwargs: CP.kwargs,
    ) -> "Paginator[RT]": ...

    @overload
    def paginate(
        self,
        request: "R[CP, CT]",
        map_func: Callable[["Response[CT]"], list[RT]],
        *args: CP.args,
        **kwargs: CP.kwargs,
    ) -> "Paginator[RT]": ...

    def paginate(
        self,
        request: "R[CP, CT]",
        map_func: Optional[Callable[["Response[CT]"], list[RT]]] = None,
        *args: CP.args,
        **kwargs: CP.kwargs,
    ) -> "Paginator[RT]":
        return Paginator(self, request, map_func, *args, **kwargs)  # type: ignore

    @overload
    def __call__(self, version: Literal["2022-11-28"]) -> "V20221128RestNamespace": ...
    @overload
    def __call__(
        self, version: Literal["ghec-2022-11-28"]
    ) -> "GhecV20221128RestNamespace": ...

    @overload
    def __call__(self) -> "V20221128RestNamespace": ...

    def __call__(self, version: VERSION_TYPE = LATEST_VERSION) -> Any:
        g = self._github
        cache = self._cached_namespaces.setdefault(g, {})
        if version in cache:
            return cache[version]
        module = importlib.import_module(f".{VERSIONS[version]}.rest", __package__)
        namespace = module.RestNamespace(g)
        cache[version] = namespace
        return namespace
