"""DO NOT EDIT THIS FILE!

This file is automatically @generated by githubkit using the follow command:

bash ./scripts/run-codegen.sh

See https://github.com/github/rest-api-description for more information.
"""

from __future__ import annotations

from typing import Literal, Union

from pydantic import Field

from githubkit.compat import GitHubModel, model_rebuild
from githubkit.typing import Missing
from githubkit.utils import UNSET


class CodeScanningDefaultSetupUpdate(GitHubModel):
    """CodeScanningDefaultSetupUpdate

    Configuration for code scanning default setup.
    """

    state: Missing[Literal["configured", "not-configured"]] = Field(
        default=UNSET, description="The desired state of code scanning default setup."
    )
    runner_type: Missing[Literal["standard", "labeled"]] = Field(
        default=UNSET, description="Runner type to be used."
    )
    runner_label: Missing[Union[str, None]] = Field(
        default=UNSET,
        description="Runner label to be used if the runner type is labeled.",
    )
    query_suite: Missing[Literal["default", "extended"]] = Field(
        default=UNSET, description="CodeQL query suite to be used."
    )
    threat_model: Missing[Literal["remote", "remote_and_local"]] = Field(
        default=UNSET,
        description="Threat model to be used for code scanning analysis. Use `remote` to analyze only network sources and `remote_and_local` to include local sources like filesystem access, command-line arguments, database reads, environment variable and standard input.",
    )
    languages: Missing[
        list[
            Literal[
                "actions",
                "c-cpp",
                "csharp",
                "go",
                "java-kotlin",
                "javascript-typescript",
                "python",
                "ruby",
                "swift",
            ]
        ]
    ] = Field(default=UNSET, description="CodeQL languages to be analyzed.")


model_rebuild(CodeScanningDefaultSetupUpdate)

__all__ = ("CodeScanningDefaultSetupUpdate",)
